#!/usr/bin/python3

from pynwp.migration import SystemService
import argparse
import os


def validator(args):
    if not args.current_version or not args.target_version or not args.patches_path:
        return False
    else:
        return True


if __name__ == "__main__":
    parser = argparse.ArgumentParser(description='Generate list of files to exclude from migration.')
    parser.add_argument('--current-version', dest='current_version', help='Current version (upgrade is made from)')
    parser.add_argument('--target-version', dest='target_version', help='Target version (upgrade is made to)')
    parser.add_argument('--patches-path', dest='patches_path', help='Path to upgrade patches')
    parser.add_argument('--exclude-list', dest='exclude_list', help='Path to exlude list')
    args = parser.parse_args()

    versions = SystemService.get_transition_versions(
        current_version=args.current_version,
        target_version=args.target_version,
        patches_path=args.patches_path)

    with open(file=args.exclude_list, mode='w') as fo:
        for version in versions:
            exclude = os.path.join(args.patches_path, version, 'exclude')
            if not os.path.isfile(exclude):
                continue
            with open(exclude, 'r') as fi:
                for line in fi:
                    fo.write(line)
