from pynwp.migration import VersionNumber
import subprocess


class CheckVersion:
    @staticmethod
    def validate(archive_path):
        p = subprocess.run(["tar", "zxvf", archive_path, "sw-version", "--to-stdout"], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        upgrade_version = p.stdout.decode()

        if p.returncode != 0 or len(upgrade_version) == 0:
            exit("Archive does not contain sw-version file")

        current_version = open("/etc/sw-version", 'r').read().strip()
        v = VersionNumber()

        current_version = v.get_version(current_version).core_version
        upgrade_version = v.get_version(upgrade_version).core_version

        if not v.get_version(upgrade_version) >= v.get_version(current_version):
            exit("Trying to downgrade")


if __name__ == "__main__":
    import sys
    CheckVersion.validate(sys.argv[1])

